//+------------------------------------------------------------------+
//|                                         PriceChannel+Signals.mq4 |
//|                                 Copyright  2008, Nick A. Zhilin |
//|                                                  rebus58@mail.ru |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, Nick A. Zhilin"
#property link      "rebus58@mail.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 SteelBlue
#property indicator_color3 Aqua
#property indicator_color4 Red

extern int Periods=20;
extern int CCIPeriod=70;

//---- buffers
double UpBorder[];
double DnBorder[];
double SU[];
double SD[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorShortName("PriceChannel+Signals");
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,UpBorder);
   SetIndexLabel(0,"UpBorder");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,DnBorder);
   SetIndexLabel(1,"DnBorder");
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,233);
   SetIndexBuffer(2,SU);
   SetIndexLabel(2,"SignalUp");
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,234);
   SetIndexBuffer(3,SD);
   SetIndexLabel(3,"SignalDown");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| DynamicRS                                                        |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
   double CCI;

//----
   i=Bars-counted_bars-1;

   while(i>=0)
     {
      UpBorder[i]=High[iHighest(NULL,0,MODE_HIGH,Periods,i+1)];
      DnBorder[i]=Low[iLowest(NULL,0,MODE_LOW,Periods,i+1)];
      CCI=iCCI(NULL,0,CCIPeriod,PRICE_MEDIAN,i);

      if(High[i+2]>=UpBorder[i+2] 
         && High[i+1]<UpBorder[i+1] 
         && High[i]<UpBorder[i]
         && CCI<100)
          SD[i]=UpBorder[i];
         
      if(Low[i+2]<=DnBorder[i+2] 
         && Low[i+1]>DnBorder[i+1] 
         && Low[i]>DnBorder[i]
         && CCI>-100)
          SU[i]=DnBorder[i];

      i--;
     }


//----
   return(0);
  }
//+------------------------------------------------------------------+
